#!/usr/bin/env python
# -*- coding: utf-8 -*-
# ##########################
# ADAPT copyright statement:
# Copyright 2006 National Technology & Engineering Solutions of Sandia, LLC (NTESS). Under the terms of Contract DE-NA0003525 with NTESS, the U.S. Government retains certain rights in this software. This software is distributed under the GNU Lesser General Public License version 3 or later.
# ##########################
import threading
import time
import sys
import os


log_mutex = threading.Semaphore()
log_last_messages = {}


class AdaptLogging:
    @staticmethod
    def log(universe, message, do_timestamp=True, logfile=None, force=None):
        global log_mutext
        global log_last_messages
        log_mutex.acquire()
        try:
            if universe not in log_last_messages:
                log_last_messages[universe] = '<empty>'
            if force or (message != log_last_messages[universe]):
                msg = ''
                if do_timestamp:
                    msg += '%s: ' % (str(time.asctime()))
                msg += message
                if logfile:
                    dir = os.path.dirname(logfile)
                    if len(dir) > 0 and not os.access(dir, os.F_OK):
                        os.makedirs(dir)
                    f = open(logfile, 'a')
                    f.write(str(msg))
                sys.stdout.write(str(msg))
                log_last_messages[universe] = str(message)
        finally:
            log_mutex.release()
