#!/usr/bin/env python
# -*- coding: utf-8 -*-
# ##########################
# ADAPT copyright statement:
# Copyright 2006 National Technology & Engineering Solutions of Sandia, LLC (NTESS). Under the terms of Contract DE-NA0003525 with NTESS, the U.S. Government retains certain rights in this software. This software is distributed under the GNU Lesser General Public License version 3 or later.
# ##########################
from threading import Lock
import sys

DatabaseAccessLock = None
debug = False
sql_connect_mode = None

DatabaseAccessLock = Lock()


def GetDatabaseAccessLock():
    global DatabaseAccessLock
    Result = None
    
    if DatabaseAccessLock is None:
        DatabaseAccessLock = Lock()
    Result = DatabaseAccessLock
    return Result


class SqlConnectMode:
    (mysql) = range(1)

try:
    import mysql
    import mysql.connector
    from mysql.connector import conversion
    sql_connect_mode = SqlConnectMode.mysql
except ImportError:
    print('ADAPT requires the MySQL python connector maintained by Oracle at https://dev.mysql.com/downloads/connector/python/')
    sys.exit(1)


def db_escape(val):
    return conversion.MySQLConverter().escape(val)
